
MTFilter = { _mesh = nil, _material = nil, _model = nil }

function MTFilter:new()
	local o = {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function MTFilter:initialize(vs, fs, define)
	print("MTFilter:initialize: " .. vs .. " " .. fs)
	local matrix = Matrix.new()
	
	self._mesh = Mesh.createMesh(VertexFormat.new({ VertexFormat.Element.new(VertexFormat.POSITION, 2),--顶点坐标
													VertexFormat.Element.new(VertexFormat.TEXCOORD0, 2),--纹理坐标
													VertexFormat.Element.new(VertexFormat.TEXCOORD1, 2)}, 3), 4)--素材纹理坐标
	self._mesh:setPrimitiveType(Mesh.TRIANGLE_STRIP)
	self._model = Model.create(self._mesh)
	self._material = self._model:setMaterial(vs, fs, define)
	self._material:getParameter("u_projectionMatrix"):setMatrix(matrix)
	matrix = nil
end

function MTFilter:enableBlend()
	self._material:getStateBlock():setBlend(true)
	self._material:getStateBlock():setBlendSrc(RenderState.BLEND_SRC_ALPHA)
	self._material:getStateBlock():setBlendDst(RenderState.BLEND_ONE_MINUS_SRC_ALPHA)
    
end

function MTFilter:setVertexData(data)
	self._mesh:setVertexData(data)
end

function MTFilter:draw()
	self._model:draw()
end

function MTFilter:release()
	self._mesh = nil
	self._model = nil
	self._material = nil
end